--Shadow of the Blade
--Kevin Pereksta
--Idea by Scott Pereksta
--Music Scott Pereksta

print = love.graphics.print

---Load Maps
local Deck = require('MAPS/deck')

--Load Libs
local MapSetup = require('LIBS/MAPSETUP')
local Drawing = require('LIBS/DRAWING')
local Movement = require('LIBS/MOVEMENT')

function love.load()
	
	love.graphics.setMode(20 * 32, 20 * 32, false, true, 0)
	love.graphics.setCaption("Silence of the Blade")
	
	--Load Images
	
	--Player
	Player = {}
	
	--Still
	Player[1] = love.graphics.newImage("Pics/Player/Player.png")
	
	--Slash Animation
	Player[2] = love.graphics.newImage("Pics/Player/PlayerSlash1.png")
	Player[3] = love.graphics.newImage("Pics/Player/PlayerSlash2.png")
	Player[4] = love.graphics.newImage("Pics/Player/PlayerSlash3.png")

	--Cop
	Cop = {}
	
	--Still
	Cop[1] = love.graphics.newImage("Pics/Cop/Cop.png")
	
	--Shoot Animation
	Cop[2] = love.graphics.newImage("Pics/Cop/CopShoot1.png")
	Cop[3] = love.graphics.newImage("Pics/Cop/CopShoot2.png")
	Cop[4] = love.graphics.newImage("Pics/Cop/CopShoot3.png")
	
	--Tiles
	Tiles = {}
	Tiles[0] = love.graphics.newImage("Pics/TERRAIN/Grass.png")
	Tiles[1] = love.graphics.newImage("Pics/TERRAIN/BOX.png")
	Tiles[2] = love.graphics.newImage("Pics/TERRAIN/CONCRETE.png")
	Tiles[3] = love.graphics.newImage("Pics/TERRAIN/WATER.png")
	Tiles[4] = love.graphics.newImage("Pics/TERRAIN/WOOD.png")
	
	--Set some Variables
	
	GAME = {}
	GAME.STATE = 0
	GAME.MODE = 0
	
	PLAYER = {}
	PLAYER.HEALTH = 100
	PLAYER.X = 0
	PLAYER.Y = 0
	PLAYER.ROTATION = 0
	PLAYER.STATE = 0
	
	
	MOVE_SPEED = 0.01
	
	
	MAP = {}
	COLLISION = {}
	SHADOW = {}
	SHADOWCAST = {}
	SPAWN = {}
	
	
	
	CURSOR = {}
	CURSOR.X = 0
	CURSOR.Y = 0
end



function love.draw()
	--Game State
	if GAME.MODE == 2 then
		drawBase()   --Draws Non ShadowCasting layer
		drawPlayers() --Draws Players
		-- drawShadows() --Draws Shadows
		drawCasters() --Draws Shadowcasting layer
	end
end


function love.update()
	CURSOR.X = love.mouse.getX()
	CURSOR.Y = love.mouse.getY()


	--Splash
	if GAME.MODE == 0 then
		GAME.MODE = 1
	end
	
	--Menu
	if GAME.MODE == 1 then
		LoadMap(1)
		PLAYER.X = SPAWN[1]
		PLAYER.Y = SPAWN[2]
		GAME.MODE = 2
	end		
	
	--In Game
	if GAME.MODE == 2 then
		getAimAngle()
		
		if love.keyboard.isDown("a") then
			MoveLeft()
		end
		if love.keyboard.isDown("d") then
			MoveRight()
		end
		if love.keyboard.isDown("w") then
			MoveUp()
		end
		if love.keyboard.isDown("s") then
			MoveDown()
		end
	end
end